
function logURL(requestDetails) {
  //console.log("Request: " + JSON.stringify(requestDetails));
}

function logHeader(headers) {
  //console.log("Headers: " + JSON.stringify(headers));
}

function logResponseStarted(response) {
  //console.log("ResponseStarted: " + JSON.stringify(response));
}

function logResponse(response) {
  if ( Object.prototype.hasOwnProperty.call(response, 'responseHeaders') ) {
  for ( var i=0;i<response.responseHeaders.length;i++ ) {
    if ( response.responseHeaders[i].name == "content-encoding" ) {
      if ( response.responseHeaders[i].value == "gzip" ) {
        var binData = new Uint8Array(response.responseBody); 
        var gunzip = new Zlib.Gunzip(binData);
        var data = gunzip.decompress();
        response.responseBody = String.fromCharCode.apply(null, new Uint16Array(data)); 
      }
    }
  }
  }
  console.log("Response: " + JSON.stringify(response));
}

browser.webRequest.onBeforeRequest.addListener(
  logURL,
  {urls: ["<all_urls>"]} /*, ["requestBody"] */
);

browser.webRequest.onBeforeSendHeaders.addListener(
  logHeader,
  {urls: ["<all_urls>"]},
  ["requestHeaders"]
);

browser.webRequest.onResponseStarted.addListener(
  logResponseStarted,
  {urls: ["<all_urls>"]},
  ["responseHeaders"]
);

browser.webRequest.onCompleted.addListener(
  logResponse,
  {urls: ["<all_urls>"]},
  ["responseHeaders", "responseBody"]
);

/*
function onFlushed() {
  console.log(`In-memory cache flushed`);
}

function onError(error) {
  console.log(`Error: ${error}`);
}

var flushingCache = browser.webRequest.handlerBehaviorChanged();
flushingCache.then(onFlushed, onError);

*/

